/* tcptd.c  - Server for tcp-Test */

#include "inet.h"
#include <sys/time.h>
int debug=0;

void talk(int sockfd)
{ 
   long n,c=0l,lgt,count,nlgt,ncount,ist,*ac;
   float sec;
   char buff[65004];
   struct timeval tv1,tv2;
   struct timezone tz1,tz2;

   /* lesen laenge*/
   read(sockfd,&nlgt,sizeof(nlgt));
   write(sockfd,&nlgt,sizeof(nlgt));
   /* lesen Paketanzahl */
   read(sockfd,&ncount,sizeof(ncount));
   gettimeofday(&tv1,&tz1);
   write(sockfd,&ncount,sizeof(ncount));
   lgt=ntohl(nlgt);
   count=ntohl(ncount);
   fprintf(stderr,"Blocklaenge: %ld, Bloecke: %ld\n",lgt,count);
   lgt=lgt+4;
   for (ist=1; ist<=count; ist++){
      c=0;
      while( c < lgt ) {
         n=read(sockfd,&buff[c],lgt-c);
	 if (n <= 0) {
	      fprintf(stderr,"Lesefehler: Soll: %ld, Ist: %ld\n",c,n);
	      exit(1);
         }
	 c+=n;
      }
      ac=(long *) &buff[0];
      c=ntohl(*ac);
      if (c != ist ) printf("Blockfolgefehler: Soll: %ld, Ist: %ld\n",ist,c);
   }
   gettimeofday(&tv2,&tz2);
   sec=((tv2.tv_sec-tv1.tv_sec)*1000000+(tv2.tv_usec-tv1.tv_usec))/1000000.0;
   fprintf(stderr,"Duration: %f Sekunden\n",sec);
   fprintf(stderr,"KBytes/Sekunde: %f\n",((count*lgt)/1024)/sec);
   fprintf(stderr,"Letzte Blocknummer: %ld\nready\n\n",c);
}

int main(int argc,char *argv[])
{
   int sockfd, newsockfd, clilen, childpid;
   struct sockaddr_in  cli_addr, serv_addr;
        int i;

   if (( sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
      fprintf(stderr,"server: can't open stream socket\n");
      exit(-1);
        }
   bzero((char *) &serv_addr, sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   serv_addr.sin_port = htons(SERV_TCP_PORT);
   if ((i=bind(sockfd, (struct sockaddr *) &serv_addr,
                                    sizeof(serv_addr))) < 0){
      fprintf(stderr,
                   "server: can't bind local address: %d\n",i);
      exit(-2);
   }
/*next*/
   listen(sockfd,5);
   for (;;) {
      clilen = sizeof(cli_addr);
      newsockfd = 
         accept(sockfd, (struct sockaddr *) &cli_addr, (socklen_t *) &clilen);
      if  (newsockfd < 0){
         fprintf(stderr,"server: accept error\n");
         exit(-3);
      }
      if ((childpid = fork()) < 0) {
         fprintf(stderr,"server: fork error\n");
         exit(-4);
      }
      else if (childpid == 0) {
              close(sockfd);
              talk(newsockfd);
              exit(0);
           }
      close(newsockfd);
   }
}
